*
      SUBROUTINE PAR_GESVN( NAME, N, NPROW, NPCOL, NB, MMIN,
     $                      OUTFILE, NPRT )
*
*       
* PDGESV, PDGESV1, PDGESV2, PDGESV3
*
*  
      INTEGER            N, MMIN, NB, NPROW, NPCOL, NPRT
      CHARACTER*(*)      NAME, OUTFILE, TRANS
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6, NOUT = 12, TRANS='N')
*
*  
      INTEGER            I, IPA, IPB, IPX, IPW, IPPIV, NPROCS1,
     $                   LCM, LCMQ,  MXNP, MXNQ, NQB, NQRHS,
     $                   NRHS, NBRHS, NB0, WORKSIZ,
     $                   LWORK, LIWORK
*
      COMMON             J
*  
      INTEGER            ICEIL, ILCM, NUMROC
      EXTERNAL           ICEIL, ILCM, NUMROC
*
*  
*
*  
*
*      IA=JA=IB=JB=IX=JX=IAF=JAF= 1
*
      NRHS = 1
      NBRHS = 1
      NQRHS = 1
*
      IF( NB .NE. 0 ) GO TO 51
      WRITE(NPR, FMT = *)' NB = 0 ! '
      GO TO 10
   51 IF( NPROW .NE. 0 ) GO TO 52
      WRITE(NPR, FMT = *)' NPROW = 0 ! '
      GO TO 10
   52 IF( NPCOL .NE. 0 ) GO TO 5
      WRITE(NPR, FMT = *)' NPCOL = 0 ! '
      GO TO 10
*
    5 MXNP = NUMROC( N, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXNP
      MXLLDB = MXLLDA
*
*     A
      IPA = 1
*
*       B
      IPB = IPA + MXLLDA*MXNQ
*
*      
*   
*
      IPPIV = IPB + MXLLDB*NQRHS
      LIPIV = ICEIL( 4*(MXNP+NB), 8 )
      IPW = IPPIV + MAX( MXNP, LIPIV )
*
      IF( NAME .NE. 'PDGESV3' ) GOTO 1
*
      IPAF = IPPIV + MAX( MXNP, LIPIV )
      IPX = IPAF + MXLLDA*MXNQ
*
      IPFER = IPX + MXLLDB*NQRHS
      IPBER = IPFER + MXLLDB*NQRHS
      IPWOR = IPBER + MXLLDB*NQRHS
*
      NQB = ICEIL( N, NB*NPCOL )
      LCM = ILCM( NPROW, NPCOL )
      LCMQ = LCM / NPCOL
*
*   ,    PDGESV3
*
      LWORK = 4*MXNP + MXNQ + ICEIL(NQB, LCMQ)*NB
      LIWORK = MXNP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
*
      GO TO 3
*
    1 IF( NAME .NE. 'PDGESV2' ) GOTO 7
*
      IPWOR =IPPIV + MAX( MXNP, LIPIV )
*
*   ,    PDGESV2
*
      LWORK = 2*MXNP + 2*MXNQ
     $       + MAX(2, MAX(NB*MAX(1, ICEIL(NPROW-1, NPCOL)),
     $                   MXNQ + NB*MAX(1, ICEIL(NPCOL-1, NPROW))))
      LIWORK = MXNP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GOTO 3
    7 IF( NAME .NE. 'PDGESV' .AND. NAME .NE. 'PDGESV1') GOTO 10
          GO TO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, MXNP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
*  
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1) GO TO 8
      IF( J .NE. 1 ) GO TO 8
*
*     
*
        WRITE( NPR, FMT = 9992 )NAME
        WRITE( NPR, FMT = 9998 )N, N, NB, NB, NPROW, NPCOL
        WRITE( NPR, FMT = 9997 )MMIN
        WRITE( NPR, FMT = * ) '     '
        WRITE( NPR, FMT = * )'    IPA,    IPB,   IPPIV,  IPW,   MMIN'
        WRITE( NPR, FMT = 9994 )IPA, IPB, IPPIV, IPW, MMIN
*
        IF( NAME .NE. 'PDGESV3' ) GOTO 2
        WRITE( NPR, FMT = * )'   IPAF,   IPX, IPFER,   IPBER, IPWOR'
        WRITE( NPR, FMT = 9994 )IPAF, IPX, IPFER, IPBER, IPWOR
    4   IF( NAME .EQ. 'PDGESV' ) GOTO 2
        WRITE( NPR, FMT = 9983 ) TRANS
    2   CONTINUE
*
 9994 FORMAT( / 5I9 /)
 9983 FORMAT( / 'TRANS = ', A /)
 9985 FORMAT( / 9I5 /)
*
    8   CONTINUE
*
*        
*   ,  
*
**         OPEN( NOUT, FILE = OUTFILE, STATUS = 'OLD' )
*
        IF( J .NE. 1 ) GO TO 11
*
          WRITE( NOUT, FMT = * )'  ', NAME,
     $                          '    ',N
   11   WRITE( NOUT, FMT = 2001 ) NPROW, NPCOL, NB, MMIN
*
**        WRITE( NPR, FMT = * )'PAR_GESVN 9'
*
   10 CONTINUE
*
 9992 FORMAT( / '   ',
     $       '      A X = B     ', A7/ )
 9998 FORMAT( /'     A ',I5,' *',I5,',',
     $       '  ,     ' I3,' *',I3/
     $       '    ',I3, ' *', I3 / )
 9997 FORMAT( / '       '/
     $      '    ',
     $      I9,'  '/)
** 9993 FORMAT( / '     '/)
 2001 FORMAT(/'NPROW= ',I3,' NPCOL= ',I3,'  NB = ',I3,'  MMIN = ',I3/)
*
      RETURN
      END
